# Auto CCM
Auto CCM is a tool that streamlines formatting in CAS-ILE, an interactive learning environment that is used by University of Illinois NetMath students. With Ospiro's simple browser extension, the tedious process of formatting math in CAS-ILE is a breeze.

Auto CCM is not associated with, nor endorsed by, the University of Illinois. "NetMath" and "CAS-ILE" are registered trademarks of the Board of Trustees of the University of Illinois.

For installation instructions and information on how to use Auto CCM, please visit our webage at https://ospiro.com/products-services/auto-ccm/.

## Disclaimer
Before you install Auto CCM, you must navigate to https://ospiro.com/products-services/auto-ccm/ and read our disclaimer.

## Copyright Status of Contributions
Auto CCM has been released into the public domain under the CC0 license. As a matter of policy, all contributors to this project are expected to forfeit the copyright to their contributions under the terms of the same license. 

## Trademark Information
"Ospiro," "Auto CCM," and the Auto CCM logo are unregistered trademarks of Ospiro Enterprises. While Ospiro has forfeited its copyright over its employees' contributions to Auto CCM, Ospiro has reserved its trademarks under the terms of the CC0 license. You are free to modify Auto CCM in any way, shape, or form, but you should not use the Auto CCM name or logo to distribute significantly modified programs in a fashion that implies endorsement by, or association with, the original Auto CCM project. 

## Version Information
### Version 2.5
August 28, 2020
* Added various IP statements. 
* To prevent potential violation of trademark law, Auto CCM is no longer officially named "Automatic CAS-ILE Control+M". "Auto CCM" is the official name of this project. 
* Fixed bug where periods at the ends of numbers were sometimes erroneously selected.
* Allowed prime derivative notation to be selected without the use function notation in certain cases.

### Version 2.4
August 19, 2020
* Fixed error where common English abbreviations would be selected as math.

### Version 2.3
August 18, 2020
* Fixed various typos.
* Major revamp of formatting system to make it less buggy
* Ctrl+S shortcut implemented.
* Ctrl+' deformatting improved to prevent non-normalized text.
* Fully migrated update hosting to Github.

### Version 2.1
August 13, 2020
* Fixed typo in button title
* Made floating alert widths more dynamic.

### Version 2.0
July 4, 2020
* Visual interface for all commands added.
* The Auto CCM icon no longer has the ability to start and stop Auto CCM. (This can be done through the new Auto CCM menu.)
* Format all is implemented.
* Minor bug fixes.

### Version 1.3
July 2, 2020
* Automatic updates for Firefox enabled.

### Version 1.2
July 1, 2020
* Support for Firefox enabled.
* Added significant documentation within the Auto CCM source code.
* Fixed bugs having to do with recognition of parentheses.
* Eliminated certain practices which are not considered ideal.

### Version 1.1
June 30, 2020
* Expanded the definition of invalid square bracket/curly brace syntax.

### Version 1.0
June 23, 2020
* Allow any word with a number in it to be selected.
* Fixed issues with awkward parntheses recognition.
* Fixed issues with multiple courses.
* Implemented Ctrl+' deformatting.
* Assorted bug fixes and cleanup

### Version 0.8
June 22, 2020
* Assorted cleanup and bug fixes.
* Changed default browser alerts to custom alert boxes.
* Notify users when invalid syntax may affect the performance of Auto CCM.
* Forbid matching math expressions that span multiple lines.

### Version 0.7
March 27, 2020
* Added shortcut for Mathematica documentation.

### Version 0.6
March 25, 2020
* Fixed another bug where some text cells were not properly processed by Auto CCM.

### Version 0.5
March 23, 2020
* Fixed major bug where some text cells were not properly processed by Auto CCM.

### Version 0.4
March 23, 2020
* Assorted bug fixes.
Added shortcut for CAS-ILE.

### Version 0.3
March 23, 2020
* Removed bloat
* Added detection for usurpation: now, users will be notified if they start another instance of Auto CCM before the previous instance has terminated.

### Version 0.2
March 23, 2020
* Fixed bug: Auto CCM icon not properly being (in)activated on different webpages.
* Implemented checks to ensure that Auto CCM fails in a controlled manner.

### Version 0.1
March 23, 2020
* This is the first version of Auto CCM. It offers basic automatic formatting capability.
